detect_partition()
{
    file -bks $device | grep -qF partition
}

describe_partition()
{
    echo "    partition tables"
}

do_partition()
{
    # Step 1: Find partition to which this sector belongs

    local partdev
    local partstart
    local partsector

    echo "# $device: partition table detected" 1>&2

    partdev="`fdisk -ul $device | awk -v sector="$sector" -F '[ *]+' '/^\// && !/Extended$/ && $2<=sector && $3>=sector {print $1,$2}'`" #`"

    if [ -z "$partdev" ]; then
        echo "# sector $sector is not part of any partition on $device" 1>&2
        exit 0
    fi

    partstart="${partdev#* }"
    partdev="${partdev% *}"
    partsector="`dc -e "$sector $partstart - p"`" # `"

    echo "offset $partstart"
    echo "device $partdev partition"
    echo "sector $partsector"

    device="$partdev"
    sector="$partsector"

    return 1
}

register_mapper "partition"
